package org.jboss.security.plugins;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;
import java.lang.reflect.Proxy;
import java.util.Hashtable;
import javax.naming.Context;
import javax.naming.Name;
import javax.naming.OperationNotSupportedException;
import javax.naming.spi.ObjectFactory;
import org.jboss.security.plugins.JaasSecurityManagerService;
import org.jboss.security.plugins.SecurityDomainContext;
import org.jboss.security.plugins.SubjectActions;

public class SecurityDomainObjectFactory implements InvocationHandler, ObjectFactory {
  public Object getObjectInstance(Object obj, Name name, Context nameCtx, Hashtable environment) throws Exception {
    ClassLoader loader = SubjectActions.getContextClassLoader();
    Class[] interfaces = { (JaasSecurityManagerService.class$javax$naming$Context == null) ? (JaasSecurityManagerService.class$javax$naming$Context = JaasSecurityManagerService.class$("javax.naming.Context")) : JaasSecurityManagerService.class$javax$naming$Context };
    Context ctx = (Context)Proxy.newProxyInstance(loader, interfaces, this);
    return ctx;
  }
  
  public Object invoke(Object obj, Method method, Object[] args) throws Throwable {
    String methodName = method.getName();
    if (methodName.equals("toString") == true)
      return "java:/jaas Context proxy"; 
    if (methodName.equals("list") == true)
      return new JaasSecurityManagerService.DomainEnumeration(JaasSecurityManagerService.access$000().keys(), JaasSecurityManagerService.access$000()); 
    if (!methodName.equals("lookup"))
      throw new OperationNotSupportedException("Only lookup is supported, op=" + method); 
    String securityDomain = null;
    Name name = null;
    if (args[0] instanceof String) {
      name = JaasSecurityManagerService.access$100().parse((String)args[0]);
    } else {
      name = (Name)args[0];
    } 
    securityDomain = name.get(0);
    SecurityDomainContext securityDomainCtx = JaasSecurityManagerService.access$200(securityDomain);
    Object binding = securityDomainCtx.getSecurityManager();
    if (name.size() == 2) {
      String request = name.get(1);
      binding = securityDomainCtx.lookup(request);
    } 
    return binding;
  }
}
